import csv
import numpy as np
import scipy.stats as ss


fin_name = input('Data file name(*.csv) = ')
with open(fin_name, 'r') as f:
    data = [v for v in csv.reader(f)]
 
fout_name = input('Output file name(*.txt) = ')
fout = open(fout_name, 'w')
fout.write('Data file name = {}\n'.format(fin_name))

print('Data file...')
for v in data:
    for w in v:
        print('{0: >7s}'.format(w), end = '')
    print()

ck_cnt = data[0][1:]
cnts = np.bincount(ck_cnt)
a = len(cnts) - 1
ck_cnt = data[1][1:]
cnts = np.bincount(ck_cnt)
b = len(cnts) - 1
N = len(data) - 2
print('a = ', a)
fout.write('\na = {}\n'.format(a))
print('b = ', b)
fout.write('b = {}\n'.format(b))
print('N = ', N)
fout.write('N = {}\n'.format(N))

Y = np.zeros((N, a, b))
for i in range(N):
    for j in range(a):
        for k in range(b):
            Y[i][j][k] = float(data[i+2][1 + k + j*b])

print('\nYijk =')
fout.write('\nYijk =\n')
for i in range(N):
    for j in range(a):
        for k in range(b):
            print('{0:>7.1f}'.format(Y[i][j][k]), end = '')
            fout.write('{0:>7.1f}'.format(Y[i][j][k]))
    print()
    fout.write('\n')

Yppp = Y.mean()
print('\nY... = {0:<10.2f}'.format(Yppp))
fout.write('\nY... = {0:<10.2f}\n'.format(Yppp))

Yijp = np.zeros((N,a))
for i in range(N):
    for j in range(a):
        Yijp[i][j] = Y[i,j,:].mean()

Ypjk = np.zeros((a, b))
for j in range(a):
    for k in range(b):
        Ypjk[j][k] = Y[:,j,k].mean()

print('\nY.jk =')
fout.write('\nY.jk =\n')
for j in range(a):
    for k in range(b):
        print('{0:>10.2f}'.format(Ypjk[j][k]), end = '')
        fout.write('{0:>10.2f}'.format(Ypjk[j][k]))
print()
fout.write('\n')

Yipp = np.zeros(N)
for i in range(N):
    Yipp[i] = Y[i,:,:].mean()
    
Ypjp = np.zeros(a)
for j in range(a):
    Ypjp[j] = Y[:,j,:].mean()
print('Y.j. = ')
fout.write('\nY.j. =\n')
for j in range(a):
    print('{0:>10.2f}'.format(Ypjp[j]), end = '')
    fout.write('{0:>10.2f}'.format(Ypjp[j]))
print()
fout.write('\n')

Yppk = np.zeros(b)
for k in range(b):
    Yppk[k] = Y[:,:,k].mean()
print('Y..k =')
fout.write('\nY..k =\n')
for k in range(b):
    print('{0:>10.2f}'.format(Yppk[k]), end = '')
    fout.write('{0:>10.2f}'.format(Yppk[k]))
print()
fout.write('\n')

Yipk = np.zeros((N,b))
for i in range(N):
    for k in range(b):
        Yipk[i][k] = Y[i,:,k].mean()

SS_T = np.sum((Y - Yppp)**2)

SS_S = a * b * np.sum((Yipp - Yppp)**2)

SS_WS = SS_T - SS_S

SS_A = b * N * np.sum((Ypjp - Yppp)**2)

SS_AS = 0.0
for i in range(N):
    for j in range(a):
        SS_AS += (Yijp[i][j] - Yipp[i] - Ypjp[j] + Yppp)**2
SS_AS *= b

SS_B = a * N * np.sum((Yppk - Yppp)**2)

SS_BS = 0.0
for i in range(N):
    for k in range(b):
        SS_BS += (Yipk[i][k] - Yipp[i] - Yppk[k] + Yppp)**2
SS_BS *= a

SS_AB = 0.0
for j in range(a):
    for k in range(b):
        SS_AB += (Ypjk[j][k] - Ypjp[j] - Yppk[k] + Yppp)**2
SS_AB *= N

SS_ABS = SS_T - (SS_S + SS_A + SS_AS + SS_B + SS_BS + SS_AB)

df_T = N * a * b - 1
df_S = N - 1
df_WS = N * (a * b - 1)
df_A = a - 1
df_AS = (N - 1) * (a - 1)
df_B = b - 1
df_BS = (N - 1) * (b - 1)
df_AB = (a - 1) * (b - 1)
df_ABS = (N - 1) * (a - 1) * (b - 1)

MS_S = SS_S / df_S
MS_A = SS_A / df_A
MS_AS = SS_AS / df_AS
MS_B =  SS_B / df_B
MS_BS = SS_BS / df_BS
MS_AB = SS_AB / df_AB
MS_ABS = SS_ABS / df_ABS

F_A = MS_A / MS_AS
F_B = MS_B / MS_BS
F_AB = MS_AB / MS_ABS

p_a = 1.0 - ss.f.cdf(F_A, df_A, df_AS)
p_b = 1.0 - ss.f.cdf(F_B, df_B, df_BS)
p_ab = 1.0 - ss.f.cdf(F_AB, df_AB, df_ABS)

print('\n')
fout.write('\n\n')
print('{0: >10s}{1: >10s}{2: >10s}{3: >10s}{4: >10s}{5: >10s}'.
      format('SV', 'SS', 'df', 'MS', 'F', 'P(>F)'))
fout.write('{0: >10s}{1: >10s}{2: >10s}{3: >10s}{4: >10s}{5: >10s}\n'.
      format('SV', 'SS', 'df', 'MS', 'F', 'P(>F)'))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}'.
      format('S', SS_S, df_S, MS_S))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}\n'.
      format('S', SS_S, df_S, MS_S))
print('{0: >10s}{1: >10.2f}{2: >10.2f}'.
      format('SSw.s', SS_WS, df_WS))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}\n'.
      format('SSw.s', SS_WS, df_WS))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}'.
      format('A', SS_A, df_A, MS_A, F_A, p_a))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}\n'.
      format('A', SS_A, df_A, MS_A, F_A, p_a))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}'.
      format('AS', SS_AS, df_AS, MS_AS))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}\n'.
      format('AS', SS_AS, df_AS, MS_AS))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}'.
      format('B', SS_B, df_B, MS_B, F_B, p_b))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}\n'.
      format('B', SS_B, df_B, MS_B, F_B, p_b))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}'.
      format('BS', SS_BS, df_BS, MS_BS))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}\n'.
      format('BS', SS_BS, df_BS, MS_BS))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}'.
      format('AB', SS_AB, df_AB, MS_AB, F_AB, p_ab))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}{4: >10.2f}{5: >10.5f}\n'.
      format('AB', SS_AB, df_AB, MS_AB, F_AB, p_ab))
print('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}'.
      format('ABS', SS_ABS, df_ABS, MS_ABS))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}{3: >10.2f}\n'.
      format('ABS', SS_ABS, df_ABS, MS_ABS))
print('{0: >10s}{1: >10.2f}{2: >10.2f}'.
      format('SStotal', SS_T, df_T))
fout.write('{0: >10s}{1: >10.2f}{2: >10.2f}\n'.
      format('SStotal', SS_T, df_T))

fout.close()
print('\nOutput file {} was saved.\n'.format(fout_name))
